Subject: Re: [PATCH RFC v1 net-next] net: ethernet: mtk_ppe_offload: Allow QinQ

From: Simon Horman <[email-masked]>
Date: Mon, 14 Oct 2024 09:51:22 +0100

On Sun, Oct 13, 2024 at 08:50:56PM +0200, Eric Woudstra wrote:
> mtk_foe_entry_set_vlan() in mtk_ppe.c already seems to support
> double vlan tagging, but mtk_flow_offload_replace() in
> mtk_ppe_offload.c only allows for 1 vlan tag, optionally in
> combination with pppoe and dsa tags.
> 
> This patch adds QinQ support to mtk_flow_offload_replace().
> 
> Only PPPoE-in-Q (as before) and Q-in-Q are allowed. A combination
> of PPPoE and Q-in-Q is not allowed.
> 
> As I do not have any documentation of the ppe hardware, I do not
> know if there is any other reason to not implement Q-in-Q in
> mtk_flow_offload_replace().
> 
> Tested on the BPI-R3(mini), on non-dsa-ports and dsa-ports.
> 
> Signed-off-by: Eric Woudstra <[email-masked]>

Hi Eric,

I see that this patch supports up to two VLANs, both with EtherType 0x8100.
And assuming that is supported by the hardware, that seems fine to me.

But I winder if you know if this hardware supports other VLAN EtherTypes,
such as  0x88a8 which is described in 802.1ad?

...